// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.Azure.Management.Batch.Models
{
    /// <summary>
    /// Values returned by the RegenerateKey operation.
    /// </summary>
    public partial class BatchAccountRegenerateKeyResponse : AzureOperationResponse
    {
        private string _primaryKey;
        
        /// <summary>
        /// Required. The primary key associated with the account.
        /// </summary>
        public string PrimaryKey
        {
            get { return this._primaryKey; }
            set { this._primaryKey = value; }
        }
        
        private string _secondaryKey;
        
        /// <summary>
        /// Required. The secondary key associated with the account.
        /// </summary>
        public string SecondaryKey
        {
            get { return this._secondaryKey; }
            set { this._secondaryKey = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BatchAccountRegenerateKeyResponse
        /// class.
        /// </summary>
        public BatchAccountRegenerateKeyResponse()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the BatchAccountRegenerateKeyResponse
        /// class with required arguments.
        /// </summary>
        public BatchAccountRegenerateKeyResponse(string primaryKey, string secondaryKey)
            : this()
        {
            if (primaryKey == null)
            {
                throw new ArgumentNullException("primaryKey");
            }
            if (secondaryKey == null)
            {
                throw new ArgumentNullException("secondaryKey");
            }
            this.PrimaryKey = primaryKey;
            this.SecondaryKey = secondaryKey;
        }
    }
}
