// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// The properties for the HDInsight linkedService.
    /// </summary>
    public partial class HDInsightBYOCLinkedService : LinkedServiceProperties
    {
        private string _clusterUri;
        
        /// <summary>
        /// Required. HDInsight cluster URI.
        /// </summary>
        public string ClusterUri
        {
            get { return this._clusterUri; }
            set { this._clusterUri = value; }
        }
        
        private HCatalogProperties _hcatalog;
        
        /// <summary>
        /// Optional. Hcatalog integration properties.
        /// </summary>
        public HCatalogProperties Hcatalog
        {
            get { return this._hcatalog; }
            set { this._hcatalog = value; }
        }
        
        private string _linkedServiceName;
        
        /// <summary>
        /// Optional. Storage service name.
        /// </summary>
        public string LinkedServiceName
        {
            get { return this._linkedServiceName; }
            set { this._linkedServiceName = value; }
        }
        
        private string _password;
        
        /// <summary>
        /// Required. HDInsight cluster password.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Required. HDInsight cluster user name.
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the HDInsightBYOCLinkedService class.
        /// </summary>
        public HDInsightBYOCLinkedService()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the HDInsightBYOCLinkedService class
        /// with required arguments.
        /// </summary>
        public HDInsightBYOCLinkedService(string clusterUri, string userName, string password)
            : this()
        {
            if (clusterUri == null)
            {
                throw new ArgumentNullException("clusterUri");
            }
            if (userName == null)
            {
                throw new ArgumentNullException("userName");
            }
            if (password == null)
            {
                throw new ArgumentNullException("password");
            }
            this.ClusterUri = clusterUri;
            this.UserName = userName;
            this.Password = password;
        }
    }
}
