// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Store.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Data Lake content summary information
    /// </summary>
    public partial class ContentSummary
    {
        /// <summary>
        /// Initializes a new instance of the ContentSummary class.
        /// </summary>
        public ContentSummary() { }

        /// <summary>
        /// Initializes a new instance of the ContentSummary class.
        /// </summary>
        public ContentSummary(long? directoryCount = default(long?), long? fileCount = default(long?), long? length = default(long?), long? quota = default(long?), long? spaceConsumed = default(long?), long? spaceQuota = default(long?))
        {
            DirectoryCount = directoryCount;
            FileCount = fileCount;
            Length = length;
            Quota = quota;
            SpaceConsumed = spaceConsumed;
            SpaceQuota = spaceQuota;
        }

        /// <summary>
        /// Gets or sets the number of directories.
        /// </summary>
        [JsonProperty(PropertyName = "directoryCount")]
        public long? DirectoryCount { get; set; }

        /// <summary>
        /// Gets or sets the number of files.
        /// </summary>
        [JsonProperty(PropertyName = "fileCount")]
        public long? FileCount { get; set; }

        /// <summary>
        /// Gets or sets the number of bytes used by the contet.
        /// </summary>
        [JsonProperty(PropertyName = "length")]
        public long? Length { get; set; }

        /// <summary>
        /// Gets or sets the namespace quota of this directory.
        /// </summary>
        [JsonProperty(PropertyName = "quota")]
        public long? Quota { get; set; }

        /// <summary>
        /// Gets or sets the disk space consumed by the content.
        /// </summary>
        [JsonProperty(PropertyName = "spaceConsumed")]
        public long? SpaceConsumed { get; set; }

        /// <summary>
        /// Gets or sets the disk space quota.
        /// </summary>
        [JsonProperty(PropertyName = "spaceQuota")]
        public long? SpaceQuota { get; set; }

    }
}
