// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Represents a metric collection configuration.
    /// </summary>
    public partial class Metrics
    {
        private IList<MetricAggregation> _metricAggregations;
        
        /// <summary>
        /// Optional. The list of aggregations to generate.
        /// </summary>
        public IList<MetricAggregation> MetricAggregations
        {
            get { return this._metricAggregations; }
            set { this._metricAggregations = value; }
        }
        
        private string _resourceId;
        
        /// <summary>
        /// Optional. The resource ID of the resource the agent runs on.
        /// </summary>
        public string ResourceId
        {
            get { return this._resourceId; }
            set { this._resourceId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Metrics class.
        /// </summary>
        public Metrics()
        {
            this.MetricAggregations = new LazyList<MetricAggregation>();
        }
    }
}
