// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// The logging diagnostic settings. This allow to specify the operations
    /// to be logged and the retention.
    /// </summary>
    public partial class StorageLoggingDiagnosticSettings
    {
        private bool _delete;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether delete operations
        /// should be logged.
        /// </summary>
        public bool Delete
        {
            get { return this._delete; }
            set { this._delete = value; }
        }
        
        private bool _read;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether read operations
        /// should be logged.
        /// </summary>
        public bool Read
        {
            get { return this._read; }
            set { this._read = value; }
        }
        
        private TimeSpan _retention;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether retention
        /// operations should be logged.
        /// </summary>
        public TimeSpan Retention
        {
            get { return this._retention; }
            set { this._retention = value; }
        }
        
        private bool _write;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether write operations
        /// should be logged.
        /// </summary>
        public bool Write
        {
            get { return this._write; }
            set { this._write = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the StorageLoggingDiagnosticSettings
        /// class.
        /// </summary>
        public StorageLoggingDiagnosticSettings()
        {
        }
    }
}
