// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql
{
    /// <summary>
    /// Represents all the operations for operating on service tier advisors.
    /// Contains operations to: Retrieve.
    /// </summary>
    public partial interface IServiceTierAdvisorOperations
    {
        /// <summary>
        /// Returns information about a service tier advisor.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the Resource Group.
        /// </param>
        /// <param name='serverName'>
        /// The name of server.
        /// </param>
        /// <param name='databaseName'>
        /// The name of database.
        /// </param>
        /// <param name='serviceTierAdvisorName'>
        /// The name of service tier advisor.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Represents the response to a get service tier advisor request.
        /// </returns>
        Task<ServiceTierAdvisorGetResponse> GetAsync(string resourceGroupName, string serverName, string databaseName, string serviceTierAdvisorName, CancellationToken cancellationToken);
        
        /// <summary>
        /// Returns information about service tier advisors for specified
        /// database.
        /// </summary>
        /// <param name='resourceGroupName'>
        /// The name of the Resource Group.
        /// </param>
        /// <param name='serverName'>
        /// The name of server.
        /// </param>
        /// <param name='databaseName'>
        /// The name of database.
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// Represents the response to a list service tier advisor request.
        /// </returns>
        Task<ServiceTierAdvisorListResponse> ListAsync(string resourceGroupName, string serverName, string databaseName, CancellationToken cancellationToken);
    }
}
