// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Represents an item- or document-level indexing error.
    /// </summary>
    public partial class ItemError
    {
        /// <summary>
        /// Initializes a new instance of the ItemError class.
        /// </summary>
        public ItemError() { }

        /// <summary>
        /// Initializes a new instance of the ItemError class.
        /// </summary>
        public ItemError(string key = default(string), string errorMessage = default(string))
        {
            Key = key;
            ErrorMessage = errorMessage;
        }

        /// <summary>
        /// Gets the key of the item for which indexing failed.
        /// </summary>
        [JsonProperty(PropertyName = "key")]
        public string Key { get; private set; }

        /// <summary>
        /// Gets the message describing the error that occurred while
        /// attempting to index the item.
        /// </summary>
        [JsonProperty(PropertyName = "errorMessage")]
        public string ErrorMessage { get; private set; }

    }
}
