// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.Automation.Models;

namespace Microsoft.WindowsAzure.Management.Automation.Models
{
    /// <summary>
    /// The response model for the get cloud service operation.
    /// </summary>
    public partial class CloudServiceGetResponse : AzureOperationResponse
    {
        private string _geoLocation;
        
        /// <summary>
        /// Optional. The location associated with the cloud service.
        /// </summary>
        public string GeoLocation
        {
            get { return this._geoLocation; }
            set { this._geoLocation = value; }
        }
        
        private IList<CloudServiceGetResponse.Resource> _resources;
        
        /// <summary>
        /// Optional. A collection of resources.
        /// </summary>
        public IList<CloudServiceGetResponse.Resource> Resources
        {
            get { return this._resources; }
            set { this._resources = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CloudServiceGetResponse class.
        /// </summary>
        public CloudServiceGetResponse()
        {
            this.Resources = new LazyList<CloudServiceGetResponse.Resource>();
        }
        
        /// <summary>
        /// A resource.
        /// </summary>
        public partial class Resource
        {
            private string _eTag;
            
            /// <summary>
            /// Optional. ETag identifying the current entity revision on the
            /// server.
            /// </summary>
            public string ETag
            {
                get { return this._eTag; }
                set { this._eTag = value; }
            }
            
            private SubscriptionIntrinsicSettings _intrinsicSettings;
            
            /// <summary>
            /// Optional. Gets or sets the intrinsic settings of resource.
            /// </summary>
            public SubscriptionIntrinsicSettings IntrinsicSettings
            {
                get { return this._intrinsicSettings; }
                set { this._intrinsicSettings = value; }
            }
            
            private string _label;
            
            /// <summary>
            /// Optional. Label of the resource.
            /// </summary>
            public string Label
            {
                get { return this._label; }
                set { this._label = value; }
            }
            
            private string _name;
            
            /// <summary>
            /// Optional. A name for the resource. The name must be unique
            /// within the subscription ID and cloud service.
            /// </summary>
            public string Name
            {
                get { return this._name; }
                set { this._name = value; }
            }
            
            private IDictionary<string, string> _outputItems;
            
            /// <summary>
            /// Optional.
            /// </summary>
            public IDictionary<string, string> OutputItems
            {
                get { return this._outputItems; }
                set { this._outputItems = value; }
            }
            
            private string _plan;
            
            /// <summary>
            /// Optional. The plan of the resource.
            /// </summary>
            public string Plan
            {
                get { return this._plan; }
                set { this._plan = value; }
            }
            
            private string _resourceProviderNamespace;
            
            /// <summary>
            /// Optional. Namespace identifier for the resource provider.
            /// </summary>
            public string ResourceProviderNamespace
            {
                get { return this._resourceProviderNamespace; }
                set { this._resourceProviderNamespace = value; }
            }
            
            private string _schemaVersion;
            
            /// <summary>
            /// Optional. Optional version of the intrinsic properties for the
            /// resource. If not specified, you must conform to the default
            /// contract resource.
            /// </summary>
            public string SchemaVersion
            {
                get { return this._schemaVersion; }
                set { this._schemaVersion = value; }
            }
            
            private string _type;
            
            /// <summary>
            /// Optional. The Type for the resource.
            /// </summary>
            public string Type
            {
                get { return this._type; }
                set { this._type = value; }
            }
            
            /// <summary>
            /// Initializes a new instance of the Resource class.
            /// </summary>
            public Resource()
            {
                this.OutputItems = new LazyDictionary<string, string>();
            }
        }
    }
}
