// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Network.Models;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// An effective route within an effective route table.
    /// </summary>
    public partial class EffectiveRoute
    {
        private IList<string> _addressPrefixes;
        
        /// <summary>
        /// Optional. Gets or sets the address prefixes that apply to this
        /// route, in CIDR format.
        /// </summary>
        public IList<string> AddressPrefixes
        {
            get { return this._addressPrefixes; }
            set { this._addressPrefixes = value; }
        }
        
        private EffectiveNextHop _effectiveNextHop;
        
        /// <summary>
        /// Required. Gets or sets the effective next hop for this route.
        /// </summary>
        public EffectiveNextHop EffectiveNextHop
        {
            get { return this._effectiveNextHop; }
            set { this._effectiveNextHop = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the Route.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _source;
        
        /// <summary>
        /// Required. Gets or sets the ource of this route.
        /// </summary>
        public string Source
        {
            get { return this._source; }
            set { this._source = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Required. Gets or sets the status of this route.
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the EffectiveRoute class.
        /// </summary>
        public EffectiveRoute()
        {
            this.AddressPrefixes = new LazyList<string>();
        }
    }
}
