// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.RemoteApp.Models;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// Similar in structure to the VNet class but used as the RequestBody for
    /// PUT requests.
    /// </summary>
    public partial class ActiveDirectoryConfigParameter : ActiveDirectoryConfig
    {
        /// <summary>
        /// Initializes a new instance of the ActiveDirectoryConfigParameter
        /// class.
        /// </summary>
        public ActiveDirectoryConfigParameter()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ActiveDirectoryConfigParameter
        /// class with required arguments.
        /// </summary>
        public ActiveDirectoryConfigParameter(string domainName, string userName, string password)
            : this()
        {
            if (domainName == null)
            {
                throw new ArgumentNullException("domainName");
            }
            if (userName == null)
            {
                throw new ArgumentNullException("userName");
            }
            if (password == null)
            {
                throw new ArgumentNullException("password");
            }
            this.DomainName = domainName;
            this.UserName = userName;
            this.Password = password;
        }
    }
}
