// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.RecoveryServices.Models
{
    /// <summary>
    /// Operation error of latest opertion on the Resource
    /// </summary>
    public partial class ResourceErrorInfo
    {
        private string _extendedCode;
        
        /// <summary>
        /// Optional. Extended code of error for latest operation on the
        /// Resource
        /// </summary>
        public string ExtendedCode
        {
            get { return this._extendedCode; }
            set { this._extendedCode = value; }
        }
        
        private int _httpCode;
        
        /// <summary>
        /// Optional. HTTP code of error for latest operation on the Resource
        /// </summary>
        public int HttpCode
        {
            get { return this._httpCode; }
            set { this._httpCode = value; }
        }
        
        private string _message;
        
        /// <summary>
        /// Optional. Message of error for latest operation on the Resource
        /// </summary>
        public string Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceErrorInfo class.
        /// </summary>
        public ResourceErrorInfo()
        {
        }
    }
}
