// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple
{
    /// <summary>
    /// All Operations related to CloneVolume  (see
    /// http://msdn.microsoft.com/en-us/library/azure/FILLTHISPART.aspx for
    /// more information)
    /// </summary>
    public partial interface ICloneVolumeOperations
    {
        /// <summary>
        /// Clone a backup element.
        /// </summary>
        /// <param name='sourceDeviceId'>
        /// The identifier of the source device from which clone is to be
        /// triggered
        /// </param>
        /// <param name='triggerCloneRequest'>
        /// The parameters required for clone operation
        /// </param>
        /// <param name='customRequestHeaders'>
        /// The Custom Request Headers which client must use
        /// </param>
        /// <param name='cancellationToken'>
        /// Cancellation token.
        /// </param>
        /// <returns>
        /// This is the Job Response for all Device Job Related Calls
        /// </returns>
        Task<JobResponse> TriggerAsync(string sourceDeviceId, TriggerCloneRequest triggerCloneRequest, CustomRequestHeaders customRequestHeaders, CancellationToken cancellationToken);
    }
}
