// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Represents a request to restore a backup.
    /// </summary>
    public partial class RestoreBackupRequest
    {
        private string _backupSetId;
        
        /// <summary>
        /// Required. This is the BackupSet to trigger Recovery from.
        /// </summary>
        public string BackupSetId
        {
            get { return this._backupSetId; }
            set { this._backupSetId = value; }
        }
        
        private string _snapshotId;
        
        /// <summary>
        /// Optional. The snapshot identifier. This must be null in case the
        /// complete backup set needs to be restored and non-null if restoring
        /// a particular snapshot.
        /// </summary>
        public string SnapshotId
        {
            get { return this._snapshotId; }
            set { this._snapshotId = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RestoreBackupRequest class.
        /// </summary>
        public RestoreBackupRequest()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the RestoreBackupRequest class with
        /// required arguments.
        /// </summary>
        public RestoreBackupRequest(string backupSetId)
            : this()
        {
            if (backupSetId == null)
            {
                throw new ArgumentNullException("backupSetId");
            }
            this.BackupSetId = backupSetId;
        }
    }
}
