// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class represents virtual disk group (volume group).
    /// </summary>
    public partial class VirtualDiskGroup
    {
        private string _instanceId;
        
        /// <summary>
        /// Optional. Gets or sets the instance id of the volume group
        /// </summary>
        public string InstanceId
        {
            get { return this._instanceId; }
            set { this._instanceId = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the name of the volume group
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private OperationInProgress _operationInProgress;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether any operation is
        /// in progress or not
        /// </summary>
        public OperationInProgress OperationInProgress
        {
            get { return this._operationInProgress; }
            set { this._operationInProgress = value; }
        }
        
        private IList<string> _virtualDiskList;
        
        /// <summary>
        /// Required. Gets or sets list of volumes associated with the volume
        /// group.
        /// </summary>
        public IList<string> VirtualDiskList
        {
            get { return this._virtualDiskList; }
            set { this._virtualDiskList = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualDiskGroup class.
        /// </summary>
        public VirtualDiskGroup()
        {
            this.VirtualDiskList = new List<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the VirtualDiskGroup class with
        /// required arguments.
        /// </summary>
        public VirtualDiskGroup(string name, List<string> virtualDiskList)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (virtualDiskList == null)
            {
                throw new ArgumentNullException("virtualDiskList");
            }
            this.Name = name;
            this.VirtualDiskList = virtualDiskList;
        }
    }
}
